#include<bits/stdc++.h>
using namespace std;

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	int x[n], y[n];
	for (int i = 0; i < n; i++){
		cin >> x[i] >> y[i];
	}
	if (n == 4){
		double a, b, c, s, p, mn;
		mn = 1000000000000000000; 
		for (int i = 0; i < n; i++){
			for (int j = i + 1; j < n; j++){
				for (int k = j + 1; k < n; k++){
					a = sqrt(pow(abs(x[i] - x[j]), 2) + pow(abs(y[i] - y[j]), 2));
					b = sqrt(pow(abs(x[i] - x[k]), 2) + pow(abs(y[i] - y[k]), 2));
					c = sqrt(pow(abs(x[j] - x[k]), 2) + pow(abs(y[j] - y[k]), 2));
					s = (a + b + c) / 2;
					p = sqrt(s * (s - a) * (s - b) * (s - c));
					mn = min(mn, p);
				}
			}
		}
		cout << mn;
	}
}